; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\macros\macros.asm

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

      include \masm32\include\dialogs.inc

      dlgproc PROTO :DWORD,:DWORD,:DWORD,:DWORD

    .data?
        hInstance dd ?

    .code

; 

start:

      mov hInstance, FUNC(GetModuleHandle,NULL)

      call main

      invoke ExitProcess,eax

; 

main proc

    Dialog "Scorpion Dialog", \             ; caption
           "MS Sans Serif",10, \            ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            12, \                           ; number of controls
            50,50,230,150, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgBitmap 5,10,8,123

    DlgEdit ES_LEFT or WS_BORDER or WS_TABSTOP,75,10,120,12,200
    DlgButton "...",WS_TABSTOP,200,10,12,12,160

    DlgEdit ES_LEFT or WS_BORDER or WS_TABSTOP,75,30,120,12,201
    DlgButton "...",WS_TABSTOP,200,30,12,12,161

    DlgEdit ES_LEFT or WS_BORDER or WS_TABSTOP,75,50,120,12,202
    DlgButton "...",WS_TABSTOP,200,50,12,12,162

    DlgEdit ES_LEFT or WS_BORDER or WS_TABSTOP,75,70,120,12,203
    DlgButton "...",WS_TABSTOP,200,70,12,12,163

    DlgButton "Button 1",WS_TABSTOP,58,100,50,12,250
    DlgButton "Button 2",WS_TABSTOP,110,100,50,12,251
    DlgButton "Exit",WS_TABSTOP,162,100,50,12,252

    CallModalDialog hInstance,0,dlgproc,NULL

    ret

main endp

; 

dlgproc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL fname$  :DWORD
    LOCAL pattern :DWORD

    .if uMsg == WM_INITDIALOG
      invoke SendMessage,hWin,WM_SETICON,1,
                         FUNC(LoadIcon,NULL,IDI_ASTERISK)

      invoke LoadMenu,hInstance,600
      invoke SetMenu,hWin,eax

    .elseif uMsg == WM_COMMAND
       sas pattern, "All files",0,"*.*",0

      .if wParam == 160
        mov fname$, OpenFileDlg(hWin,hInstance,"Open File",pattern)
      .elseif wParam == 161
        mov fname$, OpenFileDlg(hWin,hInstance,"Open File",pattern)
      .elseif wParam == 162
        mov fname$, OpenFileDlg(hWin,hInstance,"Open File",pattern)
      .elseif wParam == 163
        mov fname$, OpenFileDlg(hWin,hInstance,"Open File",pattern)

      .elseif wParam == 250     ; button 1
        ; nop
      .elseif wParam == 251     ; button 2
        ; nop
      .elseif wParam == 252     ; Exit
        jmp quit_dialog
      .endif

    .elseif uMsg == WM_CLOSE
      quit_dialog:
      invoke EndDialog,hWin,0

    .endif

    xor eax, eax
    ret

dlgproc endp

; 

end start
